# will also apply to all subpackages also, but since they all depend on
# ruby = %version anyways for now, it doesn't really matter...
%if %{_use_internal_dependency_generator}
%define __noautoreq 'ruby\\(abi\\)'
%else
%define _requires_exceptions ruby\(abi\)
%endif

%define my_target_cpu %{_target_cpu}
%ifarch amd64
%define my_target_cpu x86_64
%endif

%define subver 2.1
%define abiver 2.1.0

%bcond_with tcltk

Summary:	Object Oriented Script Language
Name:		ruby
Version:	2.1.10
Release:	1
License:	Ruby or GPLv2+
Group:		Development/Ruby
Url:		http://www.ruby-lang.org/
Source0:	ftp://ftp.ruby-lang.org/pub/ruby/%{subver}/ruby-%{version}.tar.xz
Source1:	http://www.rubycentral.com/faq/rubyfaqall.html
Source2:	http://dev.rubycentral.com/downloads/files/ProgrammingRuby-0.4.tar.bz2
# from ruby 1.9, to prevent file conflicts
Source4:	ruby-mode.el
Patch0:		ruby-do_not_propagate_no-undefined.patch
# Use shared libs as opposed to static for mkmf
# See bug rhbz#428384
Patch1:		ruby-2.1.2-mkmf-use-shared.patch
Patch2:		ruby-2.1.2-do-not-use-system-ruby-to-generate-ri-doc.patch
# http://redmine.ruby-lang.org/issues/5108
Patch3:		ruby-2.1.2-stdout-rouge-fix.patch
# backport from upstream
Patch4:		rubygems-2.2-docs.patch
Patch5:		rubygems-2.2-buildroot.patch

BuildRequires:	byacc
BuildRequires:	db52-devel
BuildRequires:	gdbm-devel
BuildRequires:	readline-devel
BuildRequires:	pkgconfig(ncurses)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(yaml-0.1)
BuildRequires:	pkgconfig(zlib)
%if %{with tcltk}
BuildRequires:	tcl-devel
BuildRequires:	pkgconfig(tk)
%else
Obsoletes:	ruby-tk < %{EVRD}
%endif
%rename		ruby-rexml
%rename		ruby-irb
%rename		ruby-libs
%rename		ruby-rdoc
%rename		ruby1.9
%rename		ruby-rake
%rename		rubygem-rake
%rename		ruby-RubyGems
Provides:	rubygems = %{EVRD}

# explicit file provides (since such requires are automatically added by find-requires)
Provides:	/usr/bin/ruby
Provides:	ruby(abi) = %{abiver}

%description
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl).  It is simple, straight-forward, and extensible.

%files -f %{name}.list
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/README
%doc %{_docdir}/%{name}
%{_bindir}/*
%dir %{_prefix}/lib/%{name}/
%dir %{_prefix}/lib/%{name}/gems
%dir %{_prefix}/lib/%{name}/gems/%{abiver}
%{_mandir}/*/*
%{_datadir}/emacs/site-lisp/*
%dir %{_prefix}/lib/%{name}/gems/%{abiver}/gems
%dir %{_prefix}/lib/%{name}/gems/%{abiver}/gems/rake-*
%dir %{_prefix}/lib/%{name}/gems/%{abiver}/gems/rake-*/bin
%{_prefix}/lib/%{name}/gems/%{abiver}/gems/rake-*/bin/rake
%dir %{_prefix}/lib/%{name}/gems/%{abiver}/gems/rdoc-*
%dir %{_prefix}/lib/%{name}/gems/%{abiver}/gems/rdoc-*/bin
%{_prefix}/lib/%{name}/gems/%{abiver}/gems/rdoc-*/bin/rdoc
%{_prefix}/lib/%{name}/gems/%{abiver}/gems/rdoc-*/bin/ri
%dir %{_prefix}/lib/%{name}/gems/%{abiver}/gems/test-unit-*
%dir %{_prefix}/lib/%{name}/gems/%{abiver}/gems/test-unit-*/bin
%{_prefix}/lib/%{name}/gems/%{abiver}/gems/test-unit-*/bin/testrb
%dir %{_prefix}/lib/%{name}/gems/%{abiver}/specifications
%{_prefix}/lib/%{name}/gems/%{abiver}/specifications/default/*.gemspec
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/*

#----------------------------------------------------------------------------

%define libname %mklibname ruby %{subver}

%package -n	%{libname}
Summary:	Shared main library for ruby %{subver}
Group:		System/Libraries

%description -n %{libname}
This package contains the shared ruby %{subver} library.

%files -n %{libname}
%{_libdir}/libruby.so.%{subver}*

#----------------------------------------------------------------------------

%package doc
Summary:	Documentation for the powerful language Ruby
Group:		Development/Ruby
BuildArch:	noarch
%rename		ruby1.9-doc

%description doc
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl). It is simple, straight-forward, and extensible.

This package contains the Ruby's documentation

%files doc
%{_datadir}/ri
%dir %{_docdir}/%{name}-%{version}
%{_docdir}/%{name}-%{version}/COPYING*
%{_docdir}/%{name}-%{version}/ChangeLog
%{_docdir}/%{name}-%{version}/README.*
%{_docdir}/%{name}-%{version}/FAQ.html
%{_docdir}/%{name}-%{version}/sample
%{_docdir}/%{name}-%{version}/ProgrammingRuby*

#----------------------------------------------------------------------------

%package devel
Summary:	Development file for the powerful language Ruby
Group:		Development/Ruby
Requires:	%{name} = %{EVRD}
%rename		ruby-static
%rename		ruby1.9-devel

%description devel
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl). It is simple, straight-forward, and extensible.

This package contains the Ruby's devel files.

%files devel
%{_includedir}/ruby-*
%{_libdir}/libruby-static.a
%{_libdir}/libruby.so
%{_libdir}/pkgconfig/ruby-%{subver}.pc
%{_libdir}/pkgconfig/ruby.pc

#----------------------------------------------------------------------------

%if %{with tcltk}
%package tk
Summary:	Tk extension for the powerful language Ruby
Group:		Development/Ruby
Requires:	%{name} = %{version}
%rename		ruby1.9-tk

%description tk
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl). It is simple, straight-forward, and extensible.

This package contains the Tk extension for Ruby.

%files tk
%{_prefix}/lib/%{name}/%{abiver}/%{my_target_cpu}-%{_target_os}/tcltk*
%{_prefix}/lib/%{name}/%{abiver}/%{my_target_cpu}-%{_target_os}/tk*
%{_prefix}/lib/%{name}/%{abiver}/tcltk*
%{_prefix}/lib/%{name}/%{abiver}/tk*
%endif

#----------------------------------------------------------------------------

%prep
%setup -q
%patch0 -p1 -b .undefined
%patch1 -p1 -b .shared~
%patch2 -p1 -b .ri
%patch3 -p1 -b .stdout~
%patch4 -p1 -b .docs~
%patch5 -p1 -b .buildroot~

%build
autoreconf -fi
touch configure.in

CFLAGS=`echo %{optflags} | sed 's/-fomit-frame-pointer//'`
%configure2_5x \
	--enable-shared \
	--disable-rpath \
	--enable-pthread \
	--with-sitedir=%{_prefix}/lib/ruby/%{abiver}/site_ruby \
	--with-vendordir=%{_prefix}/lib/ruby/%{abiver}/vendor_ruby \
	--with-rubylibprefix=%{_prefix}/lib/ruby

# Force verconf.h regeneration (for build with frozen time)
[ -f verconf.h ] && rm verconf.h
%make

%install
%makeinstall_std install-doc

install -d %{buildroot}%{_docdir}/%{name}-%{version}
cp -a COPYING* ChangeLog README* sample %{buildroot}%{_docdir}/%{name}-%{version}
install -m644 %{SOURCE1} -D %{buildroot}%{_docdir}/%{name}-%{version}/FAQ.html

install -m644 %{SOURCE4} -D %{buildroot}%{_datadir}/emacs/site-lisp/ruby-mode.el

install -d %{buildroot}%{_sysconfdir}/emacs/site-start.d
cat <<EOF >%{buildroot}%{_sysconfdir}/emacs/site-start.d/%{name}.el
(autoload 'ruby-mode "ruby-mode" "Ruby editing mode." t)
(add-to-list 'auto-mode-alist '("\\\\.rb$" . ruby-mode))
(add-to-list 'interpreter-mode-alist '("ruby" . ruby-mode))
EOF

tar -C %{buildroot}%{_docdir}/%{name}-%{version} -xjf %{SOURCE2}
mv %{buildroot}%{_docdir}/%{name}-%{version}/ProgrammingRuby-*/{html/*,}
rm -rf %{buildroot}%{_docdir}/%{name}-%{version}/ProgrammingRuby-*/{html,xml}/

# Make the file/dirs list, filtering out tcl/tk and devel files
find %{buildroot}%{_prefix}/lib/ruby/%{abiver} \
	\( -not -type d -printf "%%p\n" \) \
	-or \( -type d -printf "%%%%dir %%p\n" \) \
| sed -e 's#%{buildroot}##g' \
| egrep -v '/(tcl)?tk|(%{my_target_cpu}-%{_target_os}/.*[ha]$)' > %{name}.list

# Fix scripts permissions and location
find %{buildroot} sample -type f | file -i -f - | grep text | cut -d: -f1 >text.list
cat text.list | xargs chmod 0644
#  Magic grepping to get only files with '#!' in the first line
cat text.list | xargs grep -n '^#!' | grep ':1:#!' | cut -d: -f1 >shebang.list
cat shebang.list | xargs sed -i -e 's|/usr/local/bin|/usr/bin|; s|\./ruby|/usr/bin/ruby|'
cat shebang.list | xargs chmod 0755

pushd %{buildroot}%{_libdir}/pkgconfig/
ln -s ruby-%{subver}.pc ruby.pc
popd

%changelog

* Tue Jan 17 2017 alzim <alzim@bk.ru> 2.1.10-1
- (2c96484) Merge pull request #1 from import/ruby:rosa2016.1
- (2c96484) Updated to 2.1.10


